----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 06/27/2019 10:13:57 AM
-- Design Name: 
-- Module Name: LEDs_controller - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity LEDs_controller is
Generic ( 
simulation : boolean := FALSE--TRUE
);
Port ( 
    clk : in std_logic;--100 MHz oscillator (E3)
    rst : in std_logic;
    LEDs : out std_logic_vector(3 downto 0)
);
end LEDs_controller;

architecture Behavioral of LEDs_controller is

signal count : unsigned (26 downto 0) := (others=>'0');
signal LEDs_COUNT : std_logic_vector (3 downto 0) := (others=>'0');

constant DLY :time :=1 ns;


begin

sim_on: if simulation=TRUE generate
LEDs_COUNT <= std_logic_vector(count(3  downto 0));--count(3 downto 0);
end generate;

sim_off: if simulation=FALSE generate
LEDs_COUNT <= std_logic_vector(count(26  downto 23));--count(26 downto 23);
end generate;


cnt_proc: process (clk, rst)
begin
    if rst='1' then
        count <= (others => '0') after DLY;
    elsif rising_edge(clk) then
        count <= count + 1 after DLY;
    end if;
end process;

LEDs <= LEDs_COUNT;

end Behavioral;
