library ieee;
use     ieee.std_logic_1164.all;
use     ieee.numeric_std.all;

use     work.common_pkg.all;

entity debouncer is
port 
(                   
  clk                 		: in    std_logic;
  signal_in                 : in    std_logic;
  signal_out                : out   std_logic
 );
end debouncer;

architecture rtl of debounce is



signal signal_in_sync          : std_logic_vector(2 downto 0) := (others => '0');
signal rise_fall     : std_logic;
signal signal_in_sync      : std_logic;
signal cnt           : unsigned(29 downto 0) := (others => '0');

-- Dout
signal dout_i        : std_logic := '0';


begin

  process (Clk) 
  begin
    if rising_edge(Clk) then
      signal_in_sync    <= signal_in_sync(1 downto 0) & signal_in;
    end if;
  end process;

  r_edge_f_edge <= signal_in_sync(1) xor signal_in_sync(2);
  input_sync  <= signal_in_sync(2);

sim_on: if simulation=TRUE generate
MAX_COUNT <= 100;
end generate;

sim_off: if simulation=FALSE generate
MAX_COUNT <= 1000000000;
end generate;
  --
  process (Clk) 
  begin
    if rising_edge(Clk) then
      if (r_edge_f_edge = '1') then
        cnt <= (others => '0');
      else
        if (cnt = MAX_count) then
          cnt <= (others => '0');
        else
          cnt <= cnt + 1;
        end if;
      end if;
    end if;
  end process;

  -- ---------------------------------------------------------------------------  
  --  Dout
  -- ---------------------------------------------------------------------------
  --
  process (Clk) 
  begin
    if rising_edge(Clk) then
      if (cnt = MAX_count) then
        signal_out_i <= input_sync; 
      end if;
    end if;
  end process;
    
  -- Connect Output(s)
  signal_out <= signal_out_i;

end rtl;

